/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the ReportCohortEntry type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ReportCohortEntry{}

// ReportCohortEntry String fields availablity depends on selected grouping
type ReportCohortEntry struct {
	InteractionId *string `json:"interaction_id,omitempty"`
	// Available only with group by interaction_id
	InteractionName *string `json:"interaction_name,omitempty"`
	ChannelId *string `json:"channel_id,omitempty"`
	EntryPointId *string `json:"entry_point_id,omitempty"`
	LocationId *string `json:"location_id,omitempty"`
	Messenger *string `json:"messenger,omitempty"`
	TriggerType *string `json:"trigger_type,omitempty"`
	EntryType *string `json:"entry_type,omitempty"`
	Language *string `json:"language,omitempty"`
	BrowserName *string `json:"browser_name,omitempty"`
	DeviceName *string `json:"device_name,omitempty"`
	CountryCode *string `json:"country_code,omitempty"`
	Segment *string `json:"segment,omitempty"`
	Label *string `json:"label,omitempty"`
	Date *string `json:"date,omitempty"`
	WeekDay *string `json:"week_day,omitempty"`
	Year *string `json:"year,omitempty"`
	Month *string `json:"month,omitempty"`
	CalendarWeek *string `json:"calendar_week,omitempty"`
	Day *string `json:"day,omitempty"`
	Hour *string `json:"hour,omitempty"`
	Version *string `json:"version,omitempty"`
	ContextValue *string `json:"context_value,omitempty"`
	Interactions int32 `json:"interactions"`
	UniqueContacts int32 `json:"unique_contacts"`
	Consents int32 `json:"consents"`
	ChatStarted int32 `json:"chat_started"`
	MainActions int32 `json:"main_actions"`
	Investments int32 `json:"investments"`
}

// NewReportCohortEntry instantiates a new ReportCohortEntry object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewReportCohortEntry(interactions int32, uniqueContacts int32, consents int32, chatStarted int32, mainActions int32, investments int32) *ReportCohortEntry {
	this := ReportCohortEntry{}
	this.Interactions = interactions
	this.UniqueContacts = uniqueContacts
	this.Consents = consents
	this.ChatStarted = chatStarted
	this.MainActions = mainActions
	this.Investments = investments
	return &this
}

// NewReportCohortEntryWithDefaults instantiates a new ReportCohortEntry object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewReportCohortEntryWithDefaults() *ReportCohortEntry {
	this := ReportCohortEntry{}
	return &this
}

// GetInteractionId returns the InteractionId field value if set, zero value otherwise.
func (o *ReportCohortEntry) GetInteractionId() string {
	if o == nil || IsNil(o.InteractionId) {
		var ret string
		return ret
	}
	return *o.InteractionId
}

// GetInteractionIdOk returns a tuple with the InteractionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetInteractionIdOk() (*string, bool) {
	if o == nil || IsNil(o.InteractionId) {
		return nil, false
	}
	return o.InteractionId, true
}

// HasInteractionId returns a boolean if a field has been set.
func (o *ReportCohortEntry) HasInteractionId() bool {
	if o != nil && !IsNil(o.InteractionId) {
		return true
	}

	return false
}

// SetInteractionId gets a reference to the given string and assigns it to the InteractionId field.
func (o *ReportCohortEntry) SetInteractionId(v string) {
	o.InteractionId = &v
}

// GetInteractionName returns the InteractionName field value if set, zero value otherwise.
func (o *ReportCohortEntry) GetInteractionName() string {
	if o == nil || IsNil(o.InteractionName) {
		var ret string
		return ret
	}
	return *o.InteractionName
}

// GetInteractionNameOk returns a tuple with the InteractionName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetInteractionNameOk() (*string, bool) {
	if o == nil || IsNil(o.InteractionName) {
		return nil, false
	}
	return o.InteractionName, true
}

// HasInteractionName returns a boolean if a field has been set.
func (o *ReportCohortEntry) HasInteractionName() bool {
	if o != nil && !IsNil(o.InteractionName) {
		return true
	}

	return false
}

// SetInteractionName gets a reference to the given string and assigns it to the InteractionName field.
func (o *ReportCohortEntry) SetInteractionName(v string) {
	o.InteractionName = &v
}

// GetChannelId returns the ChannelId field value if set, zero value otherwise.
func (o *ReportCohortEntry) GetChannelId() string {
	if o == nil || IsNil(o.ChannelId) {
		var ret string
		return ret
	}
	return *o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetChannelIdOk() (*string, bool) {
	if o == nil || IsNil(o.ChannelId) {
		return nil, false
	}
	return o.ChannelId, true
}

// HasChannelId returns a boolean if a field has been set.
func (o *ReportCohortEntry) HasChannelId() bool {
	if o != nil && !IsNil(o.ChannelId) {
		return true
	}

	return false
}

// SetChannelId gets a reference to the given string and assigns it to the ChannelId field.
func (o *ReportCohortEntry) SetChannelId(v string) {
	o.ChannelId = &v
}

// GetEntryPointId returns the EntryPointId field value if set, zero value otherwise.
func (o *ReportCohortEntry) GetEntryPointId() string {
	if o == nil || IsNil(o.EntryPointId) {
		var ret string
		return ret
	}
	return *o.EntryPointId
}

// GetEntryPointIdOk returns a tuple with the EntryPointId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetEntryPointIdOk() (*string, bool) {
	if o == nil || IsNil(o.EntryPointId) {
		return nil, false
	}
	return o.EntryPointId, true
}

// HasEntryPointId returns a boolean if a field has been set.
func (o *ReportCohortEntry) HasEntryPointId() bool {
	if o != nil && !IsNil(o.EntryPointId) {
		return true
	}

	return false
}

// SetEntryPointId gets a reference to the given string and assigns it to the EntryPointId field.
func (o *ReportCohortEntry) SetEntryPointId(v string) {
	o.EntryPointId = &v
}

// GetLocationId returns the LocationId field value if set, zero value otherwise.
func (o *ReportCohortEntry) GetLocationId() string {
	if o == nil || IsNil(o.LocationId) {
		var ret string
		return ret
	}
	return *o.LocationId
}

// GetLocationIdOk returns a tuple with the LocationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetLocationIdOk() (*string, bool) {
	if o == nil || IsNil(o.LocationId) {
		return nil, false
	}
	return o.LocationId, true
}

// HasLocationId returns a boolean if a field has been set.
func (o *ReportCohortEntry) HasLocationId() bool {
	if o != nil && !IsNil(o.LocationId) {
		return true
	}

	return false
}

// SetLocationId gets a reference to the given string and assigns it to the LocationId field.
func (o *ReportCohortEntry) SetLocationId(v string) {
	o.LocationId = &v
}

// GetMessenger returns the Messenger field value if set, zero value otherwise.
func (o *ReportCohortEntry) GetMessenger() string {
	if o == nil || IsNil(o.Messenger) {
		var ret string
		return ret
	}
	return *o.Messenger
}

// GetMessengerOk returns a tuple with the Messenger field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetMessengerOk() (*string, bool) {
	if o == nil || IsNil(o.Messenger) {
		return nil, false
	}
	return o.Messenger, true
}

// HasMessenger returns a boolean if a field has been set.
func (o *ReportCohortEntry) HasMessenger() bool {
	if o != nil && !IsNil(o.Messenger) {
		return true
	}

	return false
}

// SetMessenger gets a reference to the given string and assigns it to the Messenger field.
func (o *ReportCohortEntry) SetMessenger(v string) {
	o.Messenger = &v
}

// GetTriggerType returns the TriggerType field value if set, zero value otherwise.
func (o *ReportCohortEntry) GetTriggerType() string {
	if o == nil || IsNil(o.TriggerType) {
		var ret string
		return ret
	}
	return *o.TriggerType
}

// GetTriggerTypeOk returns a tuple with the TriggerType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetTriggerTypeOk() (*string, bool) {
	if o == nil || IsNil(o.TriggerType) {
		return nil, false
	}
	return o.TriggerType, true
}

// HasTriggerType returns a boolean if a field has been set.
func (o *ReportCohortEntry) HasTriggerType() bool {
	if o != nil && !IsNil(o.TriggerType) {
		return true
	}

	return false
}

// SetTriggerType gets a reference to the given string and assigns it to the TriggerType field.
func (o *ReportCohortEntry) SetTriggerType(v string) {
	o.TriggerType = &v
}

// GetEntryType returns the EntryType field value if set, zero value otherwise.
func (o *ReportCohortEntry) GetEntryType() string {
	if o == nil || IsNil(o.EntryType) {
		var ret string
		return ret
	}
	return *o.EntryType
}

// GetEntryTypeOk returns a tuple with the EntryType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetEntryTypeOk() (*string, bool) {
	if o == nil || IsNil(o.EntryType) {
		return nil, false
	}
	return o.EntryType, true
}

// HasEntryType returns a boolean if a field has been set.
func (o *ReportCohortEntry) HasEntryType() bool {
	if o != nil && !IsNil(o.EntryType) {
		return true
	}

	return false
}

// SetEntryType gets a reference to the given string and assigns it to the EntryType field.
func (o *ReportCohortEntry) SetEntryType(v string) {
	o.EntryType = &v
}

// GetLanguage returns the Language field value if set, zero value otherwise.
func (o *ReportCohortEntry) GetLanguage() string {
	if o == nil || IsNil(o.Language) {
		var ret string
		return ret
	}
	return *o.Language
}

// GetLanguageOk returns a tuple with the Language field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetLanguageOk() (*string, bool) {
	if o == nil || IsNil(o.Language) {
		return nil, false
	}
	return o.Language, true
}

// HasLanguage returns a boolean if a field has been set.
func (o *ReportCohortEntry) HasLanguage() bool {
	if o != nil && !IsNil(o.Language) {
		return true
	}

	return false
}

// SetLanguage gets a reference to the given string and assigns it to the Language field.
func (o *ReportCohortEntry) SetLanguage(v string) {
	o.Language = &v
}

// GetBrowserName returns the BrowserName field value if set, zero value otherwise.
func (o *ReportCohortEntry) GetBrowserName() string {
	if o == nil || IsNil(o.BrowserName) {
		var ret string
		return ret
	}
	return *o.BrowserName
}

// GetBrowserNameOk returns a tuple with the BrowserName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetBrowserNameOk() (*string, bool) {
	if o == nil || IsNil(o.BrowserName) {
		return nil, false
	}
	return o.BrowserName, true
}

// HasBrowserName returns a boolean if a field has been set.
func (o *ReportCohortEntry) HasBrowserName() bool {
	if o != nil && !IsNil(o.BrowserName) {
		return true
	}

	return false
}

// SetBrowserName gets a reference to the given string and assigns it to the BrowserName field.
func (o *ReportCohortEntry) SetBrowserName(v string) {
	o.BrowserName = &v
}

// GetDeviceName returns the DeviceName field value if set, zero value otherwise.
func (o *ReportCohortEntry) GetDeviceName() string {
	if o == nil || IsNil(o.DeviceName) {
		var ret string
		return ret
	}
	return *o.DeviceName
}

// GetDeviceNameOk returns a tuple with the DeviceName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetDeviceNameOk() (*string, bool) {
	if o == nil || IsNil(o.DeviceName) {
		return nil, false
	}
	return o.DeviceName, true
}

// HasDeviceName returns a boolean if a field has been set.
func (o *ReportCohortEntry) HasDeviceName() bool {
	if o != nil && !IsNil(o.DeviceName) {
		return true
	}

	return false
}

// SetDeviceName gets a reference to the given string and assigns it to the DeviceName field.
func (o *ReportCohortEntry) SetDeviceName(v string) {
	o.DeviceName = &v
}

// GetCountryCode returns the CountryCode field value if set, zero value otherwise.
func (o *ReportCohortEntry) GetCountryCode() string {
	if o == nil || IsNil(o.CountryCode) {
		var ret string
		return ret
	}
	return *o.CountryCode
}

// GetCountryCodeOk returns a tuple with the CountryCode field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetCountryCodeOk() (*string, bool) {
	if o == nil || IsNil(o.CountryCode) {
		return nil, false
	}
	return o.CountryCode, true
}

// HasCountryCode returns a boolean if a field has been set.
func (o *ReportCohortEntry) HasCountryCode() bool {
	if o != nil && !IsNil(o.CountryCode) {
		return true
	}

	return false
}

// SetCountryCode gets a reference to the given string and assigns it to the CountryCode field.
func (o *ReportCohortEntry) SetCountryCode(v string) {
	o.CountryCode = &v
}

// GetSegment returns the Segment field value if set, zero value otherwise.
func (o *ReportCohortEntry) GetSegment() string {
	if o == nil || IsNil(o.Segment) {
		var ret string
		return ret
	}
	return *o.Segment
}

// GetSegmentOk returns a tuple with the Segment field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetSegmentOk() (*string, bool) {
	if o == nil || IsNil(o.Segment) {
		return nil, false
	}
	return o.Segment, true
}

// HasSegment returns a boolean if a field has been set.
func (o *ReportCohortEntry) HasSegment() bool {
	if o != nil && !IsNil(o.Segment) {
		return true
	}

	return false
}

// SetSegment gets a reference to the given string and assigns it to the Segment field.
func (o *ReportCohortEntry) SetSegment(v string) {
	o.Segment = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *ReportCohortEntry) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *ReportCohortEntry) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *ReportCohortEntry) SetLabel(v string) {
	o.Label = &v
}

// GetDate returns the Date field value if set, zero value otherwise.
func (o *ReportCohortEntry) GetDate() string {
	if o == nil || IsNil(o.Date) {
		var ret string
		return ret
	}
	return *o.Date
}

// GetDateOk returns a tuple with the Date field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetDateOk() (*string, bool) {
	if o == nil || IsNil(o.Date) {
		return nil, false
	}
	return o.Date, true
}

// HasDate returns a boolean if a field has been set.
func (o *ReportCohortEntry) HasDate() bool {
	if o != nil && !IsNil(o.Date) {
		return true
	}

	return false
}

// SetDate gets a reference to the given string and assigns it to the Date field.
func (o *ReportCohortEntry) SetDate(v string) {
	o.Date = &v
}

// GetWeekDay returns the WeekDay field value if set, zero value otherwise.
func (o *ReportCohortEntry) GetWeekDay() string {
	if o == nil || IsNil(o.WeekDay) {
		var ret string
		return ret
	}
	return *o.WeekDay
}

// GetWeekDayOk returns a tuple with the WeekDay field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetWeekDayOk() (*string, bool) {
	if o == nil || IsNil(o.WeekDay) {
		return nil, false
	}
	return o.WeekDay, true
}

// HasWeekDay returns a boolean if a field has been set.
func (o *ReportCohortEntry) HasWeekDay() bool {
	if o != nil && !IsNil(o.WeekDay) {
		return true
	}

	return false
}

// SetWeekDay gets a reference to the given string and assigns it to the WeekDay field.
func (o *ReportCohortEntry) SetWeekDay(v string) {
	o.WeekDay = &v
}

// GetYear returns the Year field value if set, zero value otherwise.
func (o *ReportCohortEntry) GetYear() string {
	if o == nil || IsNil(o.Year) {
		var ret string
		return ret
	}
	return *o.Year
}

// GetYearOk returns a tuple with the Year field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetYearOk() (*string, bool) {
	if o == nil || IsNil(o.Year) {
		return nil, false
	}
	return o.Year, true
}

// HasYear returns a boolean if a field has been set.
func (o *ReportCohortEntry) HasYear() bool {
	if o != nil && !IsNil(o.Year) {
		return true
	}

	return false
}

// SetYear gets a reference to the given string and assigns it to the Year field.
func (o *ReportCohortEntry) SetYear(v string) {
	o.Year = &v
}

// GetMonth returns the Month field value if set, zero value otherwise.
func (o *ReportCohortEntry) GetMonth() string {
	if o == nil || IsNil(o.Month) {
		var ret string
		return ret
	}
	return *o.Month
}

// GetMonthOk returns a tuple with the Month field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetMonthOk() (*string, bool) {
	if o == nil || IsNil(o.Month) {
		return nil, false
	}
	return o.Month, true
}

// HasMonth returns a boolean if a field has been set.
func (o *ReportCohortEntry) HasMonth() bool {
	if o != nil && !IsNil(o.Month) {
		return true
	}

	return false
}

// SetMonth gets a reference to the given string and assigns it to the Month field.
func (o *ReportCohortEntry) SetMonth(v string) {
	o.Month = &v
}

// GetCalendarWeek returns the CalendarWeek field value if set, zero value otherwise.
func (o *ReportCohortEntry) GetCalendarWeek() string {
	if o == nil || IsNil(o.CalendarWeek) {
		var ret string
		return ret
	}
	return *o.CalendarWeek
}

// GetCalendarWeekOk returns a tuple with the CalendarWeek field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetCalendarWeekOk() (*string, bool) {
	if o == nil || IsNil(o.CalendarWeek) {
		return nil, false
	}
	return o.CalendarWeek, true
}

// HasCalendarWeek returns a boolean if a field has been set.
func (o *ReportCohortEntry) HasCalendarWeek() bool {
	if o != nil && !IsNil(o.CalendarWeek) {
		return true
	}

	return false
}

// SetCalendarWeek gets a reference to the given string and assigns it to the CalendarWeek field.
func (o *ReportCohortEntry) SetCalendarWeek(v string) {
	o.CalendarWeek = &v
}

// GetDay returns the Day field value if set, zero value otherwise.
func (o *ReportCohortEntry) GetDay() string {
	if o == nil || IsNil(o.Day) {
		var ret string
		return ret
	}
	return *o.Day
}

// GetDayOk returns a tuple with the Day field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetDayOk() (*string, bool) {
	if o == nil || IsNil(o.Day) {
		return nil, false
	}
	return o.Day, true
}

// HasDay returns a boolean if a field has been set.
func (o *ReportCohortEntry) HasDay() bool {
	if o != nil && !IsNil(o.Day) {
		return true
	}

	return false
}

// SetDay gets a reference to the given string and assigns it to the Day field.
func (o *ReportCohortEntry) SetDay(v string) {
	o.Day = &v
}

// GetHour returns the Hour field value if set, zero value otherwise.
func (o *ReportCohortEntry) GetHour() string {
	if o == nil || IsNil(o.Hour) {
		var ret string
		return ret
	}
	return *o.Hour
}

// GetHourOk returns a tuple with the Hour field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetHourOk() (*string, bool) {
	if o == nil || IsNil(o.Hour) {
		return nil, false
	}
	return o.Hour, true
}

// HasHour returns a boolean if a field has been set.
func (o *ReportCohortEntry) HasHour() bool {
	if o != nil && !IsNil(o.Hour) {
		return true
	}

	return false
}

// SetHour gets a reference to the given string and assigns it to the Hour field.
func (o *ReportCohortEntry) SetHour(v string) {
	o.Hour = &v
}

// GetVersion returns the Version field value if set, zero value otherwise.
func (o *ReportCohortEntry) GetVersion() string {
	if o == nil || IsNil(o.Version) {
		var ret string
		return ret
	}
	return *o.Version
}

// GetVersionOk returns a tuple with the Version field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetVersionOk() (*string, bool) {
	if o == nil || IsNil(o.Version) {
		return nil, false
	}
	return o.Version, true
}

// HasVersion returns a boolean if a field has been set.
func (o *ReportCohortEntry) HasVersion() bool {
	if o != nil && !IsNil(o.Version) {
		return true
	}

	return false
}

// SetVersion gets a reference to the given string and assigns it to the Version field.
func (o *ReportCohortEntry) SetVersion(v string) {
	o.Version = &v
}

// GetContextValue returns the ContextValue field value if set, zero value otherwise.
func (o *ReportCohortEntry) GetContextValue() string {
	if o == nil || IsNil(o.ContextValue) {
		var ret string
		return ret
	}
	return *o.ContextValue
}

// GetContextValueOk returns a tuple with the ContextValue field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetContextValueOk() (*string, bool) {
	if o == nil || IsNil(o.ContextValue) {
		return nil, false
	}
	return o.ContextValue, true
}

// HasContextValue returns a boolean if a field has been set.
func (o *ReportCohortEntry) HasContextValue() bool {
	if o != nil && !IsNil(o.ContextValue) {
		return true
	}

	return false
}

// SetContextValue gets a reference to the given string and assigns it to the ContextValue field.
func (o *ReportCohortEntry) SetContextValue(v string) {
	o.ContextValue = &v
}

// GetInteractions returns the Interactions field value
func (o *ReportCohortEntry) GetInteractions() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Interactions
}

// GetInteractionsOk returns a tuple with the Interactions field value
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetInteractionsOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Interactions, true
}

// SetInteractions sets field value
func (o *ReportCohortEntry) SetInteractions(v int32) {
	o.Interactions = v
}

// GetUniqueContacts returns the UniqueContacts field value
func (o *ReportCohortEntry) GetUniqueContacts() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.UniqueContacts
}

// GetUniqueContactsOk returns a tuple with the UniqueContacts field value
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetUniqueContactsOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UniqueContacts, true
}

// SetUniqueContacts sets field value
func (o *ReportCohortEntry) SetUniqueContacts(v int32) {
	o.UniqueContacts = v
}

// GetConsents returns the Consents field value
func (o *ReportCohortEntry) GetConsents() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Consents
}

// GetConsentsOk returns a tuple with the Consents field value
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetConsentsOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Consents, true
}

// SetConsents sets field value
func (o *ReportCohortEntry) SetConsents(v int32) {
	o.Consents = v
}

// GetChatStarted returns the ChatStarted field value
func (o *ReportCohortEntry) GetChatStarted() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.ChatStarted
}

// GetChatStartedOk returns a tuple with the ChatStarted field value
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetChatStartedOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChatStarted, true
}

// SetChatStarted sets field value
func (o *ReportCohortEntry) SetChatStarted(v int32) {
	o.ChatStarted = v
}

// GetMainActions returns the MainActions field value
func (o *ReportCohortEntry) GetMainActions() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.MainActions
}

// GetMainActionsOk returns a tuple with the MainActions field value
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetMainActionsOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MainActions, true
}

// SetMainActions sets field value
func (o *ReportCohortEntry) SetMainActions(v int32) {
	o.MainActions = v
}

// GetInvestments returns the Investments field value
func (o *ReportCohortEntry) GetInvestments() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Investments
}

// GetInvestmentsOk returns a tuple with the Investments field value
// and a boolean to check if the value has been set.
func (o *ReportCohortEntry) GetInvestmentsOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Investments, true
}

// SetInvestments sets field value
func (o *ReportCohortEntry) SetInvestments(v int32) {
	o.Investments = v
}

func (o ReportCohortEntry) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ReportCohortEntry) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.InteractionId) {
		toSerialize["interaction_id"] = o.InteractionId
	}
	if !IsNil(o.InteractionName) {
		toSerialize["interaction_name"] = o.InteractionName
	}
	if !IsNil(o.ChannelId) {
		toSerialize["channel_id"] = o.ChannelId
	}
	if !IsNil(o.EntryPointId) {
		toSerialize["entry_point_id"] = o.EntryPointId
	}
	if !IsNil(o.LocationId) {
		toSerialize["location_id"] = o.LocationId
	}
	if !IsNil(o.Messenger) {
		toSerialize["messenger"] = o.Messenger
	}
	if !IsNil(o.TriggerType) {
		toSerialize["trigger_type"] = o.TriggerType
	}
	if !IsNil(o.EntryType) {
		toSerialize["entry_type"] = o.EntryType
	}
	if !IsNil(o.Language) {
		toSerialize["language"] = o.Language
	}
	if !IsNil(o.BrowserName) {
		toSerialize["browser_name"] = o.BrowserName
	}
	if !IsNil(o.DeviceName) {
		toSerialize["device_name"] = o.DeviceName
	}
	if !IsNil(o.CountryCode) {
		toSerialize["country_code"] = o.CountryCode
	}
	if !IsNil(o.Segment) {
		toSerialize["segment"] = o.Segment
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.Date) {
		toSerialize["date"] = o.Date
	}
	if !IsNil(o.WeekDay) {
		toSerialize["week_day"] = o.WeekDay
	}
	if !IsNil(o.Year) {
		toSerialize["year"] = o.Year
	}
	if !IsNil(o.Month) {
		toSerialize["month"] = o.Month
	}
	if !IsNil(o.CalendarWeek) {
		toSerialize["calendar_week"] = o.CalendarWeek
	}
	if !IsNil(o.Day) {
		toSerialize["day"] = o.Day
	}
	if !IsNil(o.Hour) {
		toSerialize["hour"] = o.Hour
	}
	if !IsNil(o.Version) {
		toSerialize["version"] = o.Version
	}
	if !IsNil(o.ContextValue) {
		toSerialize["context_value"] = o.ContextValue
	}
	toSerialize["interactions"] = o.Interactions
	toSerialize["unique_contacts"] = o.UniqueContacts
	toSerialize["consents"] = o.Consents
	toSerialize["chat_started"] = o.ChatStarted
	toSerialize["main_actions"] = o.MainActions
	toSerialize["investments"] = o.Investments
	return toSerialize, nil
}

type NullableReportCohortEntry struct {
	value *ReportCohortEntry
	isSet bool
}

func (v NullableReportCohortEntry) Get() *ReportCohortEntry {
	return v.value
}

func (v *NullableReportCohortEntry) Set(val *ReportCohortEntry) {
	v.value = val
	v.isSet = true
}

func (v NullableReportCohortEntry) IsSet() bool {
	return v.isSet
}

func (v *NullableReportCohortEntry) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableReportCohortEntry(val *ReportCohortEntry) *NullableReportCohortEntry {
	return &NullableReportCohortEntry{value: val, isSet: true}
}

func (v NullableReportCohortEntry) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableReportCohortEntry) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


